

local controlmenu = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 20)



function controlmenu.finish(entry)
    if entry == "back" then
        local all_keys_binded = true
        for k,v in pairs(KEY) do
            if KEY[k].scancode == nil then
                all_keys_binded = false
            end
        end
        if not all_keys_binded then
            err_keymenu.init()
        else
            options.init()
        end
    elseif entry == "jump" then
        new_keymenu.init(KEY.jump)
    elseif entry == "left" then
        new_keymenu.init(KEY.left)
    elseif entry == "down" then
        new_keymenu.init(KEY.down)
    elseif entry == "right" then
        new_keymenu.init(KEY.right)
    elseif entry == "confirm" then
        new_keymenu.init(KEY.accept)
    elseif entry == "restart" then
        new_keymenu.init(KEY.restart)
    elseif entry == "reset controls" then
        KEY.jump.scancode = "up"
        KEY.left.scancode = "left"
        KEY.down.scancode = "down"
        KEY.right.scancode = "right"
        KEY.accept.scancode = "return"
        KEY.restart.scancode = "r"
        controlmenu.init(true)
    end
end


function controlmenu.update()
    menu:update()
    if KEY.esc.pressed then
        menu.cursor = 1
        menu:moveCursor(-1)
        menu:_finish()
        KEY.esc.pressed = false
    end
end


function controlmenu.draw()
    love.graphics.draw(IMG_BACKGROUND)
    love.graphics.setFont(TTF_TITLES)
    love.graphics.print({{1,.4,.4},LANG[47]}, 0, 20)
    love.graphics.setFont(TTF)
    menu:draw()
end


function controlmenu.init(b)
    MODE_UPD, MODE_DRAW = controlmenu.update, controlmenu.draw
    love.graphics.setFont(TTF)
    menu = menuengine.new(190, 100)
    menu:addEntry(LANG[20]..(KEY.jump.scancode or ""), controlmenu.finish, "jump")
    menu:addEntry(LANG[21]..(KEY.left.scancode or ""), controlmenu.finish, "left")
    menu:addEntry(LANG[22]..(KEY.down.scancode or ""), controlmenu.finish, "down")
    menu:addEntry(LANG[23]..(KEY.right.scancode or ""), controlmenu.finish, "right")
    menu:addEntry(LANG[24]..(KEY.accept.scancode or ""), controlmenu.finish, "confirm")
    menu:addEntry(LANG[41]..(KEY.restart.scancode or ""), controlmenu.finish, "restart")
    menu:addSep()
    menu:addSep()
    menu:addEntry(LANG[43], controlmenu.finish, "reset controls")
    menu:addSep()
    menu:addEntry(LANG[12], controlmenu.finish, "back")
    KEY.esc.pressed = false
    if b then
        menu.cursor = 1
        menu:moveCursor(-1)
        menu:moveCursor(-1)
    end
end


return controlmenu
