-- Tiles

--IMG_PLAYER = love.graphics.newImage("img/player.png")

-- Backgrounds
--IMG_BACK_MAIN = love.graphics.newImage("img/back_main.png")
IMG_BACK_ESC = love.graphics.newImage("img/eschud.png")
IMG_BACKGROUND = love.graphics.newImage("img/background.png")
IMG_INSTRUCTIONS = love.graphics.newImage("img/instructions.png")
IMG_INSTRUCTIONS2 = love.graphics.newImage("img/instructions2.png")
IMG_WINNER = love.graphics.newImage("img/winner.png")
IMG_EPISODEBACKGROUND = love.graphics.newImage("img/episodewinner.png")

TTF_TITLES = love.graphics.newFont("fonts/inconsolata-bold.ttf", 33)

-- Spritebatch
IMG_SPRITES = love.graphics.newImage("img/1.png")
--IMG_SPRITES:setFilter("linear", "nearest")
IMG_SPRITES:setFilter("nearest", "nearest")


local tileSize = 20
local function make_quad(x, y)
    return love.graphics.newQuad(x * tileSize, y * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight())
end


-- Define Quads and IDs
ID_EMPTY = 1
QUAD_EMPTY = make_quad(0,0)
ID_LAVA = 2
QUAD_LAVA = make_quad(1,0)
ID_STONE = 3
QUAD_STONE = make_quad(2,0)
ID_PLAYER = 4
QUAD_PLAYER = make_quad(3,0)
ID_FLAG = 5
QUAD_FLAG = make_quad(4,0)
ID_JUMPER = 13
QUAD_JUMPER = make_quad(12,0)
ID_SPIKESU = 9
QUAD_SPIKESU = make_quad(8,0)
ID_SPIKESL = 10
QUAD_SPIKESL = make_quad(9,0)
ID_SPIKESD = 11
QUAD_SPIKESD = make_quad(10,0)
ID_SPIKESR = 12
QUAD_SPIKESR = make_quad(11,0)

QUAD_CURSOR = make_quad(2,5)

QUAD_WINNER = make_quad(4, 4)

ID_PLAYER_RIGHT = 17
QUAD_PLAYER_RIGHT = make_quad(0, 1)
ID_PLAYER_LEFT = 18
QUAD_PLAYER_LEFT = make_quad(1, 1)
ID_PLAYER_NOTJUMP = 19
QUAD_PLAYER_NOTJUMP = make_quad(2, 1)
ID_PLAYER_REVERT = 20
QUAD_PLAYER_REVERT = make_quad(3, 1)

ID_KEY = 22
--QUAD_KEY = make_quad(5, 1)
QUAD_KEY = make_quad(0, 9)

TBL_KEYS = {
    make_quad(0, 9),
    make_quad(1, 9),
    make_quad(2, 9),
    make_quad(3, 9),
    make_quad(4, 9),
    make_quad(3, 9),
    make_quad(2, 9),
    make_quad(1, 9),
}

ID_DOOR = 21
QUAD_DOOR = make_quad(4, 1)

TBL_DOORS = {
    make_quad(0, 8),
    make_quad(1, 8),
    make_quad(2, 8),
    make_quad(3, 8),
    make_quad(4, 8),
    make_quad(5, 8),
    make_quad(6, 8),
    make_quad(7, 8),
    make_quad(8, 8),
}

ID_RED_UD = 8
ID_RED_LR = 6
QUAD_RED = make_quad(0, 5)


-- HUDs
ID_HUD = -1
QUAD_HUD_1 = make_quad(0, 7)
QUAD_HUD_2 = make_quad(1, 7)
QUAD_HUD_3 = make_quad(2, 7)
QUAD_HUD_4 = make_quad(3, 7)
QUAD_HUD_5 = make_quad(4, 7)
QUAD_HUD_6 = make_quad(5, 7)
QUAD_HUD_7 = make_quad(6, 7)
QUAD_HUD_8 = make_quad(7, 7)
QUAD_HUD_9 = make_quad(8, 7)
QUAD_HUD_X = make_quad(9, 7)
QUAD_HUD_U = make_quad(10, 7)



QUAD_FLAGS = {
    love.graphics.newQuad(0 * tileSize, 4 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(1 * tileSize, 4 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(2 * tileSize, 4 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(3 * tileSize, 4 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
}


QUAD_GAMEOVERS = {
    love.graphics.newQuad(0 * tileSize, 6 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(1 * tileSize, 6 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(2 * tileSize, 6 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(3 * tileSize, 6 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
    love.graphics.newQuad(4 * tileSize, 6 * tileSize, tileSize, tileSize, IMG_SPRITES:getWidth(), IMG_SPRITES:getHeight()),
}

-- Put IDs and Quads together.
-- Tables to create Background if found in Level (while loading).
TILES_TBL = {
    [ID_EMPTY] = QUAD_EMPTY,
    [ID_LAVA] = QUAD_LAVA,
    [ID_STONE] = QUAD_STONE,
    [ID_PLAYER] = QUAD_EMPTY,
    [ID_PLAYER_LEFT] = QUAD_EMPTY,
    [ID_PLAYER_RIGHT] = QUAD_EMPTY,
    [ID_PLAYER_NOTJUMP] = QUAD_EMPTY,
    [ID_PLAYER_REVERT] = QUAD_EMPTY,
    [ID_FLAG] = QUAD_EMPTY,
    [ID_JUMPER] = QUAD_JUMPER,
    [ID_SPIKESU] = QUAD_SPIKESU,
    [ID_SPIKESD] = QUAD_SPIKESD,
    [ID_SPIKESL] = QUAD_SPIKESL,
    [ID_SPIKESR] = QUAD_SPIKESR,
    [ID_KEY] = QUAD_EMPTY,
    [ID_DOOR] = QUAD_EMPTY,
    [ID_RED_UD] = QUAD_EMPTY,
    [ID_RED_LR] = QUAD_EMPTY,
}

-- Table to create if ID matchs (on Actions).
SPAWNTILES_TBL = {
    [ID_EMPTY] = QUAD_EMPTY,
    [ID_LAVA] = QUAD_LAVA,
    [ID_STONE] = QUAD_STONE,
    [ID_PLAYER] = QUAD_PLAYER,
    [ID_PLAYER_LEFT] = QUAD_PLAYER_LEFT,
    [ID_PLAYER_RIGHT] = QUAD_PLAYER_RIGHT,
    [ID_PLAYER_NOTJUMP] = QUAD_PLAYER_NOTJUMP,
    [ID_PLAYER_REVERT] = QUAD_PLAYER_REVERT,
    [ID_FLAG] = QUAD_FLAG,
    [ID_JUMPER] = QUAD_JUMPER,
    [ID_SPIKESU] = QUAD_SPIKESU,
    [ID_SPIKESD] = QUAD_SPIKESD,
    [ID_SPIKESL] = QUAD_SPIKESL,
    [ID_SPIKESR] = QUAD_SPIKESR,
    [ID_KEY] = QUAD_KEY,
    [ID_DOOR] = QUAD_DOOR,
    [ID_RED_UD] = QUAD_RED,
    [ID_RED_LR] = QUAD_RED,
}

-- Table of everything that hurts Player.
TBL_HURTIDS = {
    ID_LAVA,
    ID_SPIKESU,
    ID_SPIKESD,
    ID_SPIKESL,
    ID_SPIKESR,
}


BATCH_LEVEL = love.graphics.newSpriteBatch(IMG_SPRITES, 32 * 18) -- global; need in "game.lua".



function spawn(id, x, y)
    local ret = true
    if id == ID_EMPTY then
        make_empty(x, y)
    elseif id == ID_STONE then
        make_stone(x, y)
    elseif id == ID_LAVA then
        make_lava(x, y)
    elseif id == ID_SPIKESU then
        make_spike(x, y, QUAD_SPIKESU)
    elseif id == ID_SPIKESD then
        make_spike(x, y, QUAD_SPIKESD)
    elseif id == ID_SPIKESL then
        make_spike(x, y, QUAD_SPIKESL)
    elseif id == ID_SPIKESR then
        make_spike(x, y, QUAD_SPIKESR)
    elseif id == ID_FLAG then
        make_flag(x, y)
    elseif id == ID_PLAYER then
        make_player(x, y)
    elseif id == ID_PLAYER_LEFT then
        make_player_left(x, y)
    elseif id == ID_PLAYER_RIGHT then
        make_player_right(x, y)
    elseif id == ID_PLAYER_REVERT then
        make_player_revert(x, y)
    elseif id == ID_PLAYER_NOTJUMP then
        make_player_notjump(x, y)
    elseif id == ID_JUMPER then
        make_jumper(x, y)
    elseif id == ID_KEY then
        make_key(x, y)
    elseif id == ID_DOOR then
        make_door(x, y)
    elseif id == ID_RED_UD then
        make_redenemy(x, y, false)
    elseif id == ID_RED_LR then
        make_redenemy(x, y, true)
    else
        ret = false
    end
    return ret
end
