local function snd_load(sndfile)
    local self = {}
    local file = love.audio.newSource(sndfile, "static")

    function self:play()
        file:stop()
        file:play()
    end

    function self:setVolume(value)
        file:setVolume(value)
    end

    return self
end


SND_JUMP = snd_load("sounds/jump.wav")
SND_MENUERR = snd_load("sounds/menuerror.wav")
SND_ERR = snd_load("sounds/error.wav")
SND_GOAL = snd_load("sounds/goal.wav")
SND_PLACE = snd_load("sounds/place.wav")
SND_NOPLACE = snd_load("sounds/noplace.wav")
SND_KEY = snd_load("sounds/key.wav")

-- Music
MUS_MAINMENU = love.audio.newSource("music/puzzle-game.mp3", "stream")
MUS_MAINMENU:setLooping(true)

MUS_EP1 = love.audio.newSource("music/8-bit-perplexion.mp3", "stream")
MUS_EP1:setLooping(true)

MUS_EP3 = love.audio.newSource("music/pixel-quirk.mp3", "stream")
MUS_EP3:setLooping(true)
