

local episodemenu = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 24)


function episodemenu.finish(entry)
    if entry == "back" then
        mainmenu.init()
    elseif entry == "episode1" then
        game.init(0)  -- (internal) Level 0.
    elseif entry == "episode2" then
        game.init(11)
    elseif entry == "episode3" then
        game.init(11)
    elseif entry == "episode4" then
        game.init(9)
        --episodewinner.init()
    end
end


function episodemenu.update()
    menu:update()
    if KEY.esc.pressed then
        menu.cursor = 1
        menu:moveCursor(-1)
        menu:_finish()
        KEY.esc.pressed = false
    end
end


function episodemenu.draw()
    love.graphics.draw(IMG_BACKGROUND)
    love.graphics.setFont(TTF_TITLES)
    love.graphics.print({{1,.4,.4},LANG[48]}, 0, 20)
    love.graphics.setFont(TTF)
    menu:draw()
end


function episodemenu.init()
    MODE_UPD, MODE_DRAW = episodemenu.update, episodemenu.draw
    love.graphics.setFont(TTF)
    --menu = menuengine.new(250, 100)
    menu = menuengine.new(190, 120)
    menu:addEntry(LANG[37], episodemenu.finish, "episode1")
    menu:addEntry(LANG[34], episodemenu.finish, "episode2")
    menu:addEntry(LANG[35], episodemenu.finish, "episode3")
    menu:addEntry(LANG[36], episodemenu.finish, "episode4")
    menu:addSep()
    menu:addEntry(LANG[12], episodemenu.finish, "back")
    KEY.esc.pressed = false
end


return episodemenu

