

local episodewinner = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 18)


function episodewinner.finish(entry)
    if entry == "back" then
        MUS_EP3:stop()
        MUS_MAINMENU:play()
        mainmenu.init()
    end
end


function episodewinner.update()
    menu:update()
    if KEY.esc.pressed then
        menu:_finish()
        KEY.esc.pressed = false
    end
end


function episodewinner.draw()
    love.graphics.draw(IMG_EPISODEBACKGROUND)
    love.graphics.setFont(TTF_TITLES)
    love.graphics.print({{1,.4,.4},LANG[52]}, 0, 20)
    love.graphics.setFont(TTF)
    love.graphics.print("\n\n\n\n\n"
        .."    "..LANG[53].."\n\n"
        .."    "..LANG[54].."\n\n\n\n\n"
        .."    "..LANG[55]
    )
    menu:draw()
end


function episodewinner.init()
    love.audio.stop()
    MUS_EP3:play()
    MODE_UPD, MODE_DRAW = episodewinner.update, episodewinner.draw
    love.graphics.setFont(TTF)
    menu = menuengine.new(35, 300)
    menu:addEntry(LANG[12], episodewinner.finish, "back")
    KEY.esc.pressed = false
end


return episodewinner
