

local escapemenu = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 20)


function escapemenu.finish(entry)
    bga = nil
    love.audio.setVolume(1.0)
    if entry == "continue" then
        MODE_UPD, MODE_DRAW = game.upd, game.draw
    elseif entry == "back to mainmenu" then
        love.audio.stop()
        MUS_MAINMENU:play()
        mainmenu.init()
    elseif entry == "level restart" then
        game.init()
    end
end


function escapemenu.update()
    menu:update()
    if KEY.esc.pressed then
        menu.cursor = 1
        menu:_finish()
        KEY.esc.pressed = false
    end
end


function escapemenu.draw()
    love.graphics.draw(IMG_BACK_ESC, 160, 148)
    menu:draw()
end


function escapemenu.init(bg)
    bga = love.graphics.newImage(bg)
    MODE_UPD, MODE_DRAW = escapemenu.update, escapemenu.draw
    love.audio.setVolume(.4)
    love.graphics.setFont(TTF)
    menu = menuengine.new(200, 150)
    menu:addEntry(LANG[39], escapemenu.finish, "continue")
    menu:addEntry(LANG[42], escapemenu.finish, "level restart")
    menu:addEntry(LANG[40], escapemenu.finish, "back to mainmenu")
    KEY.esc.pressed = false
end


return escapemenu
