

local instructionmenu2 = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 18)
local OTTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 30)


function instructionmenu2.finish(entry)
    if entry == "back" then
        instructionmenu.init()
    elseif entry == "next" then
        mainmenu.init()
    end
end

function instructionmenu2.update()
    menu:update()
    if KEY.esc.pressed then
        menu.cursor = 2
        menu:_finish()
        KEY.esc.pressed = false
    end
    if KEY.left.pressed then
        menu.cursor = 1
        menu:moveCursor(-1)
        KEY.left.pressed = false
    elseif KEY.right.pressed then
        menu.cursor = 2
        menu:moveCursor(-1)
        KEY.right.pressed = false
    end
end


function instructionmenu2.draw()
    love.graphics.draw(IMG_INSTRUCTIONS2)
    love.graphics.setFont(TTF_TITLES)
    love.graphics.print({{1,.4,.4},LANG[50].." (2/2)"}, 0, 20)
    love.graphics.setFont(OTTF)
    love.graphics.print(LANG[2], 185, 188)
    love.graphics.setFont(TTF)
    menu:draw()
end


function instructionmenu2.init()
    MODE_UPD, MODE_DRAW = instructionmenu2.update, instructionmenu2.draw
    love.graphics.setFont(TTF)
    menu = menuengine.new(450, 300)
    menu:addEntry(LANG[51], instructionmenu2.finish, "next")
    menu:movePosition(35, 300)
    menu:addEntry(LANG[12], instructionmenu2.finish, "back")
    KEY.esc.pressed = false
end


return instructionmenu2
