

local mainmenu = {}
local menu
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 32)


function mainmenu.finish(entry)
    if entry == "start_game" then
        episodemenu.init()
    elseif entry == "options" then
        options.init()
    elseif entry == "credits" then
        credits.init()
    elseif entry == "quit" then
        quit.init()
    elseif entry == "instructions" then
        instructionmenu.init()
    end
end

function mainmenu.update()
    menu:update()
    if KEY.esc.pressed then
        menu.cursor = 1
        menu:moveCursor(-1)
        KEY.esc.pressed = false
    end
end


function mainmenu.draw()
    love.graphics.draw(IMG_BACKGROUND)
    love.graphics.setFont(TTF_TITLES)
    love.graphics.print({{1,.4,.4},LANG[45]}, 0, 20)
    love.graphics.setFont(TTF)
    menu:draw()
end


function mainmenu.init()
    MODE_UPD, MODE_DRAW = mainmenu.update, mainmenu.draw
    love.graphics.setFont(TTF)
    menu = menuengine.new(190, 120)
    menu:addEntry(LANG[1], mainmenu.finish, "start_game")
    menu:addEntry(LANG[49], mainmenu.finish, "instructions")
    menu:addEntry(LANG[2], mainmenu.finish, "options")
    menu:addEntry(LANG[3], mainmenu.finish, "credits")
    menu:addEntry(LANG[4], mainmenu.finish, "quit")
    KEY.esc.pressed = false
end


return mainmenu
