function flr(v)
    return math.floor(v+1)
end


function make_gameover()
    players = {}
    local a = {}
    local id
    for i=#actors,1,-1 do

    --for i,v in ipairs(actors) do
        --f.x,f.y,f.sx,f.sy = {},{},{},{}
        id = actors[i].id
        if  id == ID_PLAYER or id == ID_PLAYER_LEFT or id == ID_PLAYER_RIGHT or id == ID_PLAYER_NOTJUMP or id == ID_PLAYER_REVERT then
            _make_gameoveranim(actors[i].x, actors[i].y, actors[i].sx, actors[i].sy)
            table.remove(actors,i)
            for j=#players,1,-1 do
                if players[j] == actors[i] then
                    table.remove(players, j)
                end
            end
        end
    end
    SND_ERR:play()
    timed_action(500, function()game.init()end)
end


function _make_gameoveranim(x, y, sx, sy)
    local f=make_actor(x, y)
    f.sx = sx
    f.sy = sy
    f.img = QUAD_GAMEOVERS[1]
    timed_action(100, function()
        f.img = QUAD_GAMEOVERS[2]
        timed_action(100, function()
            f.img = QUAD_GAMEOVERS[3]
            timed_action(100, function()
                f.img = QUAD_GAMEOVERS[4]
                timed_action(100, function()
                    f.img = QUAD_GAMEOVERS[5]
                end)
            end)
        end)
    end)
end


function make_flag(x, y)
    local f=make_actor(x, y, QUAD_FLAG)
    timed_action(200, function()
        f.img = QUAD_FLAGS[4]
        timed_action(200, function()
            f.img = QUAD_FLAGS[3]
            timed_action(200, function()
                f.img = QUAD_FLAGS[2]
                timed_action(200, function()
                    f.img = QUAD_FLAGS[1]
                    timed_action(1200, function()
                        f.img = QUAD_FLAGS[2]
                        timed_action(200, function()
                            f.img = QUAD_FLAGS[3]
                            timed_action(200, function()
                                f.img = QUAD_FLAGS[4]
                                timed_action(200, function()
                                    make_flag(f.x, f.y)
                                    for i=#actors,1,-1 do
                                        if actors[i] == f then
                                            table.remove(actors, i)
                                            break
                                        end
                                    end
                                end)
                            end)
                        end)
                    end)
                end)
            end)
        end)
    end)
--[[
    timed_action(200, function()f.img = QUAD_FLAGS[1]end)
    timed_action(400, function()f.img = QUAD_FLAGS[2]end)
    timed_action(600, function()f.img = QUAD_FLAGS[3]end)
    timed_action(800, function()f.img = QUAD_FLAGS[4]end)
    timed_action(1000, function()make_flag(f.x, f.y)end)
    timed_action(1200, function()
        make_flag(f.x, f.y)
        for i=#actors,1,-1 do
            if actors[i] == f then
                table.remove(actors, i)
                --break
            end
        end
    end)
--]]
end


function make_player_left(x, y)
    local f=make_player(x, y, QUAD_PLAYER_LEFT)
    f.id = ID_PLAYER_LEFT
    f._update = player_update
    f._right = false
    f.update = function(f, dt)
        f._right = KEY.right.pressed
        KEY.right.pressed = false
        player_update(f, dt)
        KEY.right.pressed = f._right
    end
    f.draw = function(f)
        f.sx = false
        draw_normal(f)
    end
    return f
end


function make_player_right(x, y)
    local f=make_player(x, y, QUAD_PLAYER_RIGHT)
    f.id = ID_PLAYER_RIGHT
    f._update = player_update
    f._left = false
    f.update = function(f, dt)
        f._left = KEY.left.pressed
        KEY.left.pressed = false
        player_update(f, dt)
        KEY.left.pressed = f._left
    end
    f.draw = function(f)
        --f.sx = false
        draw_normal(f)
    end
    return f
end


function make_player_notjump(x, y)
    local f=make_player(x, y, QUAD_PLAYER_NOTJUMP)
    f.id = ID_PLAYER_NOTJUMP
    f._update = player_update
    f._jump = false
    f.update = function(f, dt)
        f._jump = KEY.jump.pressed
        KEY.jump.pressed = false
        player_update(f, dt)
        KEY.jump.pressed = f._jump
    end
    f.draw = function(f)
        draw_normal(f)
    end
    return f
end


function make_player_revert(x, y)
    local f=make_player(x, y, QUAD_PLAYER_REVERT)
    f.id = ID_PLAYER_REVERT
    f._update = player_update
    f.update = function(f, dt)
        KEY.jump.pressed,KEY.down.pressed,KEY.left.pressed,KEY.right.pressed = KEY.down.pressed,KEY.jump.pressed,KEY.right.pressed,KEY.left.pressed
        player_update(f, dt)
        KEY.jump.pressed,KEY.down.pressed,KEY.left.pressed,KEY.right.pressed = KEY.down.pressed,KEY.jump.pressed,KEY.right.pressed,KEY.left.pressed
    end
    f.draw = function(f)
        f.sx = not f.sx
        draw_normal(f)
        f.sx = not f.sx
    end
    return f
end


function make_player(x,y, img)
    local f
    if img == nil then
        f=make_actor(x, y, QUAD_PLAYER)
    else
        f=make_actor(x, y, img)
    end
--[[
    f.dx=0
    f.accdx=1000
    f.maxdx=250
    f.friction=500
    f.dy=0
    f.gravity=700
--]]
    f.id = ID_PLAYER
    f.dx=0
    f.accdx=500
    f.maxdx=125
    f.friction=250
    f.dy=0
    f.gravity=350
    f.update=player_update
    f.gameover=false
    f.max_stucks = 1000
    table.insert(players, f)
    return f
end


function player_move(f,d,dt)
    dt = dt or love.timer.getDelta()
    --local accdx = f.accdx*dt
    --f.dx = f.dx + accdx*d
    f.dx = f.dx + f.accdx*d*dt
    if f.dx > f.maxdx then f.dx = f.maxdx end
    if f.dx < -f.maxdx then f.dx = -f.maxdx end
end


function player_jump(f, d, skip_check)
    skip_check = skip_check or false
    d = d or 210
    --if is_p_solid(f.x, f.y+1) and not is_p_solid(f.x, f.y-1) and f.dy >=0 or skip_check then
    if skip_check or is_p_solid(f.x, f.y+1) and f.dy >=0 then
        if not is_p_solid(f.x, f.y-1) then
            f.dy = -d
            SND_JUMP:play()
        end
    end
end


function player_update(f, dt)
    -- Check Gameover-States
    if not f.gameover and is_p_solid(f.x, f.y, TBL_HURTIDS) then
        -- TODO: Gameover
        make_gameover()
    end

    if f.gameover then
        do return end
    else
        -- check win-state
        if is_p_solid(f.x, f.y, {ID_FLAG}) then
            -- more than one player?
            local c = 0
            local a
            for i=#actors,1,-1 do
                a = actors[i].id
                if a == ID_PLAYER or a == ID_PLAYER_LEFT or a == ID_PLAYER_RIGHT or a == ID_PLAYER_NOTJUMP or a == ID_PLAYER_REVERT then
                    c = c + 1
                end
            end
            if c == 1 then
                love.graphics.captureScreenshot(winner.init)
            --[[
            SND_GOAL:play()
            PLAYERLEVEL = PLAYERLEVEL+1
            game.init()
            --]]
            else
                SND_GOAL:setVolume(.3)
                SND_GOAL:play()
                timed_action(1000, function()SND_GOAL:setVolume(1.0)end)
                for i, v in ipairs(actors) do
                    if v == f then
                        table.remove(actors, i)
                        for j=#players,1,-1 do
                            if players[j] == v then
                                table.remove(players, j)
                                break
                            end
                        end
                        break
                    end
                end
            end
            do return end
        end

        -- Handle Controls
        if KEY.right.pressed then
                player_move(f, 1, dt)
                f.sx=false
        end
        if KEY.left.pressed then
                player_move(f, -1, dt)
                f.sx=true
        end
        -- check jumpblock
        if is_p_solid(f.x, f.y+1, {ID_JUMPER}) then
            player_jump(f, 300)
        end
        -- check jump-Button
        if KEY.jump.pressed then
                player_jump(f)
        end

        -- Step 2: Physics
        -- keep Checks if the Player stucks.
        local stuckcheck = 0
        repeat
            stuckcheck = stuckcheck + 1
            if f.dx > 0 then
                f.dx = f.dx - f.friction*dt
                if f.dx < 0 then f.dx = 0 end
            elseif f.dx < 0 then
                f.dx = f.dx + f.friction*dt
                if f.dx > 0 then f.dx = 0 end
            end
        until not is_p_solid(f.x+f.dx*dt,f.y) or stuckcheck >= f.max_stucks
        f.x = f.x + f.dx*dt

        f.dy = f.dy + f.gravity * dt
        while is_p_solid(f.x,f.y+f.dy*dt) and stuckcheck < f.max_stucks do
            stuckcheck = stuckcheck + 1
            if f.dy>0 then
                f.dy = f.dy - f.gravity*dt
                if f.dy < 0 then f.dy = 0 end
            elseif f.dy < 0 then
                f.dy = f.dy + f.gravity*dt
                if f.dy > 0 then f.dy = 0 end
            end
        end
        if stuckcheck >= f.max_stucks then
            make_gameover()
        else
            if is_p_solid(f.x,f.y+1) and f.dy>=0 then
                f.y = math.floor(f.y)
                f.dy = 0
            else
                f.y = f.y + f.dy*dt
            end

            if f.dy <-100 and not KEY.jump.pressed then
                f.dy = -100
            end
        end
    end
end


function is_solid(x, y, s)
    s = s or {ID_STONE, ID_JUMPER, ID_DOOR}
    -- needs global "level"-Table
    local ret=false
    for _,v in pairs(s) do
        if level[flr(y/20)][flr(x/20)]==v then ret = true
        elseif level[flr((y+19)/20)][flr(x/20)]==v then ret = true
        elseif level[flr(y/20)][flr((x+19)/20)]==v then ret = true
        elseif level[flr((y+19)/20)][flr((x+19)/20)]==v then ret = true
        end
        if ret then do return true end end
    end
    return false
end


function is_p_solid(x, y, s)
    -- needs global "level"-Table
    s = s or {ID_STONE, ID_JUMPER, ID_DOOR}
    local ret=false
    for _,v in pairs(s) do
        if level[flr(y/20)][flr((x+5)/20)]==v then ret = true
        elseif level[flr((y+19)/20)][flr((x+5)/20)]==v then ret = true
        elseif level[flr(y/20)][flr((x+15)/20)]==v then ret = true
        elseif level[flr((y+19)/20)][flr((x+15)/20)]==v then ret = true
        end
        if ret then do return true end end
    end
    return false
end


function is_touching_player(x, y)
    for i=1,#players do
        if players[i].x+15 > x and players[i].x < x+15 then
            if players[i].y+19 > y and players[i].y < y+19 then
                do return true end
            end
        end
    end
    return false
end


function is_touching_others(f)
    local ix = math.floor((f.x+9)/20)*20
    local iy = math.floor((f.y+9)/20)*20
    for i, v in ipairs(actors) do
        if v ~= f then
            if v.id == ID_PLAYER or v.id == ID_PLAYER_LEFT or v.id == ID_PLAYER_RIGHT or v.id == ID_PLAYER_NOTJUMP or v.id == ID_PLAYER_REVERT then
                if ix+15 > v.x and ix < v.x+15 then
                    if iy+19 > v.y and iy < v.y+19 then
                        do return true end
                    end
                end
            else
                if ix+19 > v.x and ix < v.x+19 then
                    if iy+19 > v.y and iy < v.y+19 then
                        do return true end
                    end
                end
            end
        end
    end
    return false
end
