

local quit = {}
local t = 2.0  -- Timer


-- Fake-FPS to prevent "Fast-Quit" if vsync is off.
local FPS_BUFFER = 0
local FPS = 1 / 60


function quit.update(dt)
    if KEY.esc.pressed then
        love.event.quit()
    else
        FPS_BUFFER = FPS_BUFFER + dt
        if FPS_BUFFER >= FPS then
            FPS_BUFFER = FPS_BUFFER - FPS
            t = t - .01
            MUS_MAINMENU:setVolume(t-1)
            if t <= 0 then
                love.event.quit()
            end
        end
    end
end


function quit.draw()
    love.graphics.draw(IMG_BACKGROUND)
    love.graphics.print(LANG[15], 100, 100)  -- Thank you for Playing! :)
    if t <= .25 then
        love.graphics.print("...", 100, 150)
    elseif t <= .5 then
        love.graphics.print("..", 100, 150)
    elseif t <= .75 then
        love.graphics.print(".", 100, 150)
    end
end


function quit.init()
    MODE_UPD, MODE_DRAW = quit.update, quit.draw
end


return quit
