

local resmenu = {}
local TTF = love.graphics.newFont("fonts/inconsolata-bold.ttf", 20)
local menu


function resmenu.finish(k)
    configfile.settings.x = k.w
    configfile.settings.y = k.h
    set_window()
end


function resmenu.update()
    menu:update()
end


function resmenu.draw()
    --love.graphics.draw(IMG_BACKGROUND)
    menu:draw()
    if KEY.esc.pressed then
        menu.cursor = 1
        menu:moveCursor(-1)
        menu:_finish()
        KEY.esc.pressed = false
    end

end


function resmenu.init(res)
    MODE_UPD, MODE_DRAW = resmenu.update, resmenu.draw
    love.graphics.setFont(TTF)
    menu = menuengine.new(1, 1)
    -- find out resolutions
    local modes = love.window.getFullscreenModes()
    local maxentries = 10
    local entries = 0
    local tmp
    local show
    table.sort(modes, function(a, b) return a.width*a.height < b.width*b.height end)
    for i=1,#modes do
        show = false
        if res == nil then
            show = true
        elseif res == "16_9" then
            if modes[i].width/16.0 == modes[i].height/9.0 then
                show = true
            end
        elseif res == "4_3" then
            if modes[i].width/4.0 == modes[i].height/3.0 then
                show = true
            end
        elseif res == "not169_43" then
            if not (modes[i].width/4.0 == modes[i].height/3.0 or modes[i].width/16.0 == modes[i].height/9.0) then
                show = true
            end
        end
        if entries == 16 then
            menu:movePosition(150, 1)
        elseif entries == 32 then
            menu:movePosition(300, 1)
        elseif entries == 48 then
            menu:movePosition(450, 1)
        elseif entries >= 57 then  -- prevent "overflooding" Resolution-Entries
            show = false
        end
        if show then
            menu:addEntry(modes[i].width.." x "..modes[i].height, resmenu.finish, {w=modes[i].width, h=modes[i].height})
            entries = entries + 1
        end
    end
    menu:movePosition(450, 210)
    menu:addEntry(LANG[30], resmenu.init)
    menu:addEntry(LANG[31], resmenu.init, "16_9")
    menu:addEntry(LANG[32], resmenu.init, "4_3")
    menu:addEntry(LANG[33], resmenu.init, "not169_43")
    menu:addSep()
    menu:addEntry(LANG[12], options.init)
    KEY.esc.pressed = false
end


return resmenu
